# Building Lora gateway library with autotools

## Prerequisites

If you want to cross compile the library, set up your environment and be sure that your toolchain is available in the current `PATH`.

## Build

Here are the step to build the library using the autotools:

    ./bootstrap # Only if you have fetched the sources from git
    ./configure
    make install

By default the library and the tools will be installed in `/usr/local`. You can change the prefix by using `--prefix=/my/wanted/prefix/`.

If you are using Kerlink stations, you should use the `--enable-kerlink` option.

If you are cross compiling, you should use the `--host` option with your host tuple (e.g `--host=arm-klk-linux-gnueabi`).

You can also add debug in the library by using the `--enable-debug` option. It is also possible to restrict the debug to some modules by using `--enable-debug=mod1:mod2:mod3`. The available modules are: `all`, `aux`, `gps`, `hal`, `lbt`, `reg`, `spi`.

You can also build a dota file for the library by running:

    make dota

This should create a `custo_libloragw_*.tar.gz` file.

## Examples

Here is a full example for Wirnet iGateways (iBTS, iFemto, iStation, iFemto-Evo):

    ./bootstrap # Only if you have fetched the sources from git
    ./configure --host=arm-klk-linux-gnueabi --enable-kerlink=keros --prefix=/tmp/libloragw
    make install
    make utils
