#ifndef _SX1239_H_
#define _SX1239_H_

#include <stddef.h>
#include <stdint.h>

void *sx1239_open(const char *spidev, int enable, int reset);
int sx1239_close(void *device);
int sx1239_abort(void *device);

int sx1239_set_dcc_freq(void *device, uint8_t df);
int sx1239_set_lna_gain(void *device, uint8_t lg);
int sx1239_set_bw(void *device, uint32_t bw);
int sx1239_set_br(void *device, uint32_t br);

int sx1239_start_rx(void *device, uint32_t freq);
int sx1239_rssi(void *device);

#define SX1239_HISTO_VALUE_MAX          UINT8_MAX
#define SX1239_HISTO_STEP_NB            (SX1239_HISTO_VALUE_MAX + 1)

uint16_t *sx1239_histogram(void *device, uint32_t fstart, uint32_t fstop,
                           uint32_t fstep, uint32_t samples,
                           void (*progress)(uint32_t part, uint32_t total));

uint16_t *sx1239_oneshot_histogram(void *device, uint32_t fstart, uint32_t fstop,
                                   uint32_t fstep, uint32_t samples,
                                   void (*progress)(uint32_t part, uint32_t total));

#endif
