#ifndef _SX1272_H_
#define _SX1272_H_

#include <stddef.h>
#include <stdint.h>

#define SX1272_HISTO_VALUE_MAX          UINT8_MAX
#define SX1272_HISTO_STEP_NB            (SX1272_HISTO_VALUE_MAX + 1)

int sx1272_reg_check(uint8_t addr, uint8_t val, uint8_t mask);
int sx1272_reg_set_mask(uint8_t addr, uint8_t val, uint8_t mask);
int sx1272_set_mode(uint8_t mode);
int sx1272_set_br(uint32_t br);
int sx1272_set_bw(uint32_t bw);
int sx1272_set_freq(uint32_t freq);
int sx1272_rssi(uint8_t firstAtThisFreq, int* rssi);
uint16_t *sx1272_histogram(uint32_t fstart, uint32_t fstop,
                           uint32_t fstep, uint32_t samples);
void sx1272_dumpRegs(void);
#endif
